#!/usr/bin/perl
#	$Id: tickler.pl 2353 2005-12-12 00:05:50Z jeff $
#	$Author: jeff $

# Autodetect path for FreeMED
use FindBin;
use lib "$FindBin::Bin/../lib/perl";
my $rootpath = "$FindBin::Bin/..";

# Add proper libraries for XML-RPC access and configuration data
use Frontier::Client;
use Config::IniFiles;

# Get interval parameter
my $interval = shift || '';
my $date     = shift || '';

# Get link information from the configuration file. In future, this should
# probably be generated by the FreeMED install wizard as a special XML-RPC
# account, so internal processes can use the same configuration file.
my $config = new Config::IniFiles ( -file => $rootpath.'/data/config/xmlrpc.ini' );

# Connect to FreeMED installation, and run all ticklers
my $client = Frontier::Client->new (
	url => $config->val('freemed', 'url'),
	username => $config->val('freemed', 'username'),
	password => $config->val('freemed', 'password'),
	debug => $config->val('freemed', 'debug')
);
print "Calling FreeMED.Tickler.call ( $interval )\n";
my $result = $client->call('FreeMED.Tickler.call', {
	date => $date,
	interval => $interval
});
print($result); print "\n";

